
// BANNER START
const require = (await import("node:module")).createRequire(import.meta.url);
const __filename = (await import("node:url")).fileURLToPath(import.meta.url);
const __dirname = (await import("node:path")).dirname(__filename);
// BANNER END
    

// src/utils.ts
function getNuxtStyleRouteName(node) {
  var _a;
  if (((_a = node.parent) == null ? void 0 : _a.isRoot()) && node.value.pathSegment === "")
    return "index";
  let name = node.value.subSegments.map((segment) => {
    if (typeof segment === "string")
      return `-${segment}`;
    return segment.paramName;
  }).join("");
  if (node.value.components.size && node.children.has("index"))
    name += "/";
  const parent = node.parent;
  return ((parent && !parent.isRoot() ? getNuxtStyleRouteName(parent).replace(/\/$/, "") : "") + name).replace(/^-|-$/, "");
}

export {
  getNuxtStyleRouteName
};
